#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dosrun.h"
#include "config_dosrun.h"

extern void dump ( int force );
extern word oldip,oldcs;



struct prefix_struct {
    unsigned int opsize : 1;
    unsigned int addrsize : 1;
    unsigned int rep : 1;
    unsigned int repz : 1;
    unsigned int lock : 1;
    word seg;
};

static struct prefix_struct prefix;



static byte in_emu ( word port )
{
#ifdef CONFIG_DEBUG_UNIMPLEMENTED_PORT
  if (stddebug) fprintf(stddebug,"IN EMU: unimplemented port read access, port=%04X\n",port);
#endif
  return 0xFF;
}


static void out_emu ( word port , byte data )
{
#ifdef CONFIG_DEBUG_UNIMPLEMENTED_PORT
  if (stddebug) fprintf(stddebug,"OUT EMU: unimplemented port write access, port=%04X data=%02X\n",port,data);
#endif
}



int inst_emu ( void )
{
  byte *r=DOS_PB(CS,IP); /* byte pointer for unknown instruction. let's recognize and emulate it then ! */
  bzero(&prefix,sizeof(prefix));
  prefix.seg=DS;
  /*      opsize   addrsize  rep       repz      lock      CS:       SS:       DS:       FS:       GS:       ES: */
  while (*r==0x66||*r==0x67||*r==0xF2||*r==0xF3||*r==0xF0||*r==0x2E||*r==0x36||*r==0x3E||*r==0x64||*r==0x65||*r==0x26) {
    switch (*r) {
      case 0x66 : prefix.opsize=1;
                  break;
      case 0x67 : prefix.addrsize=1;
                  break;
      case 0xF2 : prefix.rep=1;
                  break;
      case 0xF3 : prefix.repz=1;
                  break;
      case 0xF0 : prefix.lock=1;
                  break;
      case 0x2E : prefix.seg=CS;
                  break;
      case 0x36 : prefix.seg=SS;
                  break;
      case 0x3E : prefix.seg=DS;
                  break;
      case 0x64 : prefix.seg=FS;
                  break;
      case 0x65 : prefix.seg=GS;
                  break;
      case 0x26 : prefix.seg=ES;
                  break;
      default   : fprintf(stderr,"ERROR IN inst.c source !! EXITING\n");
                  exit(1);
    }
    r++;
    IP++;
  } /* while */
  switch (*r) {
		case 0x0F : if (r[1]==0x20&&r[2]==0xC0) {  /* mov eax,cr0 */
								  IP+=3;
								  EAX=0;
								  return 1;
								}
								break;
    case 0x6C :   /* insb */
    case 0x6D :   /* insw */
    case 0x6E :   /* outsb */
    case 0x6F :   /* outsw */
    case 0xEC : AL=in_emu(DX);         /* in al,dx */
                return 1;
    case 0xED :                        /* in ax,dx */
    case 0xEE : IP++;                  /* out dx,al */
		out_emu(DX,AL);
		return 1;
    case 0xEF : IP++;                  /* out dx,ax */
		out_emu(DX,AL);
		out_emu(DX+1,AH);
                return 1;
    case 0xE6 : IP+=2;                 /* out port,al */
		out_emu(r[1],AL);
		return 1;		
    case 0xE4 : IP+=2;                 /* in al,port */
		AL=in_emu(r[1]);
		return 1;		
  }
  /* oh-oh, trouble ...
     if you get here, welcome to post output for us, or better : write
     some code to emulate instruction or correct our - possibly buggy - code
     and send the patch */
  fprintf(stderr,"CAN'T EMULATE by vm86() and dosrun :\n");
  dump(1);
  return 0;
}
